#! /usr/bin/perl
# Gérald Sédrati-Dinet
# Frédéric Couchet
# License : WTFPL
#  DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#  Version 2, December 2004
#
#  Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>
#
#  Everyone is permitted to copy and distribute verbatim or modified
#  copies of this license document, and changing it is allowed as long
#  as the name is changed.
#
#  DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
#  TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
#
#  0. You just DO WHAT THE FUCK YOU WANT TO.

use 5.014;
use utf8;
use open qw(:std :encoding(UTF-8));
use LWP::Simple;

my $url = "https://www.april.org/taxonomy_all_items/term/1917/all/feed";
my $filename = "/usr/share/drupal6/lav.xml";

BEGIN {
    $ENV{OUTPUT_CHARSET} = 'UTF-8';
    $ENV{PERL_UNICODE} = 'AS';
}

use XML::RSS;

my $rss = XML::RSS->new;

my $in_file = get($url);
die "Couldn't get $url\n!" unless defined $in_file;


open(my $fh, '>:encoding(UTF-8)', $filename) or die "Could not open file '$filename' $!";

$rss->parse($in_file);

$rss->{channel}->{description} = "<p>Chaque mardi de 15 h 30 à 17 h 00, l'April, l'association de promotion et de défense du logiciel libre, propose une émission de radio d'explications et d'échanges concernant les dossiers politiques et juridiques que l'association traite et les actions qu'elle mène : <a href=\"https://april.org/libre-a-vous\">Libre à vous !</a>. Une partie de l'émission est également consacrée aux actualités et actions de type sensibilisation. L'émission est diffusée sur radio Cause Commune sur la bande FM en Île-de-France (93.1) et <a href=\"https://cause-commune.fm\">sur le site web de la radio</a>.</p><p>Donner à chacun et chacune, de manière simple et accessible les clefs pour comprendre les enjeux mais aussi proposer des moyens d'action, tel est l'objectif de l'émission.</p>";

$rss->image(title=>'Libre à vous !', url=>'https://april.org/files/libre-a-vous/banniere-radio-april-rss-200.png', link=>'https://april.org/libre-a-vous');

foreach my $item (@{$rss->{'items'}}) {
    my $ogg_enclosure = $item->{enclosure};
#    if ($ogg_enclosure and not(ref $ogg_enclosure) and $ogg_enclosure->{type} eq 'audio/ogg')
    if ($ogg_enclosure and ($ogg_enclosure->{type} eq 'audio/ogg' or $ogg_enclosure->{type} eq 'application/ogg')) {
#        print "ICI MP3\n";
    my $mp3_enclosure;
    $mp3_enclosure->{type} = 'audio/mpeg';
    $mp3_enclosure->{length} = $ogg_enclosure->{length};
    ($mp3_enclosure->{url} = $ogg_enclosure->{url}) =~ s/\.ogg$/.mp3/;
    $item->{enclosure} = [$ogg_enclosure, $mp3_enclosure];
  }
}

#say $rss->as_string;

print $fh $rss->as_string;

close $fh;
